org.cpsolver.studentsct.heuristics.studentord

## Class StudentMajorOrder

- java.lang.Object
- - org.cpsolver.studentsct.heuristics.studentord.StudentMajorOrder

- All Implemented Interfaces:
    Comparator<Student>, StudentOrder

      public class StudentMajorOrder
      extends Object
      implements StudentOrder, Comparator<Student>

  Return the given set of students ordered by their majors
  Version:
    StudentSct 1.3 (Student Sectioning)
    Copyright (C) 2007 - 2014 Tomáš Müller
    muller@unitime.org
    http://muller.unitime.org
    This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.
    This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
    You should have received a copy of the GNU Lesser General Public License along with this library; if not see http://www.gnu.org/licenses/.
  Author:
    Tomáš Müller

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `StudentMajorOrder(DataProperties config)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `compare(Student s1, Student s2)`
    `int` | `compareMajors(AreaClassificationMajor m1, AreaClassificationMajor m2)`
    `int` | `compareMajors(List<AreaClassificationMajor> m1, List<AreaClassificationMajor> m2)`
    `List<Student>` | `order(List<Student> students)` Order the given list of students

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface java.util.Comparator

      `comparing, comparing, comparingDouble, comparingInt, comparingLong, equals, naturalOrder, nullsFirst, nullsLast, reversed, reverseOrder, thenComparing, thenComparing, thenComparing, thenComparingDouble, thenComparingInt, thenComparingLong`

- - ### Constructor Detail

    - #### StudentMajorOrder

          public StudentMajorOrder(DataProperties config)

  - ### Method Detail

    - #### order

          public List<Student> order(List<Student> students)

      Order the given list of students
      Specified by:
        `order` in interface `StudentOrder`
      Parameters:
        `students` - input list of students
      Returns:
        new list of students, ordered by this criterion

    - #### compare

          public int compare(Student s1,
                             Student s2)

      Specified by:
        `compare` in interface `Comparator<Student>`

    - #### compareMajors

          public int compareMajors(List<AreaClassificationMajor> m1,
                                   List<AreaClassificationMajor> m2)

    - #### compareMajors

          public int compareMajors(AreaClassificationMajor m1,
                                   AreaClassificationMajor m2)